#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include "types.h"
#include "fonctions_coeur.h"


/* Si on se trouve dans la dernire case en bas  droite, on remonte dans la premire case en haut  gauche,
si on se trouve  la fin d'une ligne, on passe  la ligne suivante,
sinon on avance d'une case */
void case_suivante(place* p, short dim){
	if(p->y % dim == (dim-1) && p->x %dim == (dim-1)){
		p->y = p->y - (dim-1);
		p->x = p->x - (dim-1);
	}
	else{
		if(p->x % dim == (dim-1)){
			p->x = p->x - (dim-1);
			p->y = p->y + 1;
		}
		else{
			p->x = p->x + 1;
		}
	}
}


short region_nbfois(short chiffre, place p, liste** l, short taille){
	short x,i;
	x=0;
	for(i=0; i<taille; i++){
		case_suivante(&p, sqrt(taille));
		if(presence(l[p.y][p.x], chiffre))
			x++;
	}
	return x;
}


short ligne_nbfois(short chiffre, place p, liste** l, short taille){
	short x,i;
	x=0;
	for(i=0; i<taille; i++){
		if(presence(l[p.y][i], chiffre))
			x++;
	}
	return x;
}


short colonne_nbfois(short chiffre, place p, liste** l, short taille){
	short x,i;
	x=0;
	for(i=0; i<taille; i++){
		if(presence(l[i][p.x], chiffre))
			x++;
	}
	return x;
}


/* Dans chaque case de la rgion, si la liste contient plus d'un element, on supprime le chiffre de la liste */
void region_supp(short chiffre, place p, liste** l, short taille){
	short i;

	for(i=0; i<taille; i++){
		if(l[p.y][p.x]->suivant!=NULL)
			l[p.y][p.x] = supp_liste(l[p.y][p.x], chiffre);

		case_suivante(&p, sqrt(taille));
	}
}


/* Pour chaque case de la ligne, si la liste contient plus d'un element, on supprime le chiffre de la liste */
void ligne_supp(short chiffre, place p, liste** l, short taille){
	short i;

	for(i=0; i<taille; i++){
		if(l[p.y][i]->suivant!=NULL)
			l[p.y][i] = supp_liste(l[p.y][i], chiffre);
	}
}


/* Pour chaque case de la ligne, si la liste contient plus d'un element, on supprime le chiffre de la liste */
void colonne_supp(short chiffre, place p, liste** l, short taille){
	short i;

	for(i=0; i<taille; i++){
		if(l[i][p.x]->suivant!=NULL)
			l[i][p.x] = supp_liste(l[i][p.x], chiffre);
	}
}


liste supp_tous_sauf(short chiffre, liste l){
	while(l!=NULL){
		l=supp_tete(l);
	}
	l=ajout_tete(l, chiffre);

	return l;
}


liste supp_liste(liste l, short chiffre){
	liste temp, temp2, temp3;

	if(l->valeur == chiffre){
		l=supp_tete(l);
	}
	else{
		temp=l;
		/* On parcours la liste jusqu'au chiffre cherch ou jusqu'a la fin si il n'y est pas */
		while(temp!=NULL && temp->valeur<chiffre){
			temp3=temp;
			temp=temp->suivant;
		}
		/* Si on trouve le chiffre dans la liste */
		if(temp!=NULL && temp->valeur==chiffre){
			temp2=temp->suivant;
			temp3->suivant=temp2;
			free(temp);
		}
	}
	return l;
}


liste ajout_tete(liste l, short e){
	liste nouveau;

	nouveau=(element*)malloc(sizeof(element));
	nouveau->suivant=l;
  nouveau->valeur=e;

	return nouveau;
}


liste supp_tete(liste l){
	liste temp;

	if(l!=NULL){
		temp=l->suivant;
		free(l);
	}

	return(temp);
}


bool presence(liste l, short chiffre){
	liste temp;
	bool present;

	temp=l;
	present=false;
	while(temp!=NULL && !present){
		if(temp->valeur==chiffre)
			present=true;

		temp=temp->suivant;
	}
	return present;
}


bool verif_lc(short** grille, place p, short chiffre){
	short i;
	bool ok;

	ok=false;
	for(i=0; i<(p.y); i++){
		if(grille[i][p.x] == chiffre)
			ok=true;
	}

	for(i=0; i<(p.x); i++){
		if(grille[p.y][i] == chiffre)
			ok=true;
	}
	return(ok);
}


void initialiser(liste** l, short taille){
	short i,j,k;

	for(i=0; i<taille; i++){
		for(j=0; j<taille; j++){
			l[i][j] = (element*)malloc(sizeof(element));
			l[i][j] = NULL;
			for(k=taille; k>0; k--){
				l[i][j] = ajout_tete(l[i][j], k);
			}
		}
	}
}


void remplir_zero(short** grille, short taille){
	short i,j;

	for(i=0; i<taille; i++){
		for(j=0;j<taille;j=j+1){
			grille[i][j]=0;
		}
	}
}


void copie(short** grille, short** grille2, short taille){
	short i,j;

	for(i=0;i<taille;i=i+1){
		for(j=0;j<taille;j=j+1){
			grille2[i][j]=grille[i][j];
		}
	}
}


bool rempli(short** grille, short taille){
	short i,j;
	bool complet;

	complet=true;
	for(i=0; i<taille; i++){
		for(j=0; j<taille; j++){
			if(grille[i][j]==0)
				complet=false;
		}
	}
	return complet;
}
