#include <stdlib.h>
#include <stdio.h>

#include "types.h"
#include "fonctions_coeur.h"


bool resolution(short** grille, short taille){
	liste** l = NULL;
	short i, j;
	short chiffre;
	bool operation;
	bool trouve[taille][taille];
	place p;

	/* allouer de la memoire au tableau dynamique de liste */
	l = malloc(taille * sizeof(liste *));
  if (l == NULL)
    exit(0);

	for (i=0;i<taille;i++){
    l[i] = malloc(taille * sizeof(liste));
		if (l[i] == NULL){
      for (j=0;j<i;j++){
        free(l[j]);
        exit(0);
      }
    }
	}

	/* Initialise le tableau de listes de chiffres*/
	initialiser(l, taille);

	for(i=0; i<taille; i++){
		for(j=0; j<taille; j++){
			trouve[i][j]=false;
		}
	}

	do{
		operation=false;

		for(i=0; i<taille; i++){
			for(j=0; j<taille; j++){
				p.y=i;
				p.x=j;
				if(!trouve[i][j]){
					/* Si la case contient un chiffre et la liste contient plus d'un element,
					on supprime tous les elements de la liste sauf le chiffre de la case,
					on supprime la possibilit d'avoir le chiffre dans la ligne, dans la colonne et dans la region */
					if(grille[i][j]!=0 && (l[i][j])->suivant!=NULL){
						l[i][j] = supp_tous_sauf(grille[i][j], l[i][j]);
						ligne_supp(grille[i][j], p, l, taille);
						colonne_supp(grille[i][j], p, l, taille);
						region_supp(grille[i][j], p, l, taille);
						operation=true;
					}
					/* Si la case contient un chiffre et la liste ne contient qu'un element,
					on supprime la possibilit d'avoir le chiffre dans la ligne, dans la colonne, et dans la region */
					else if(grille[i][j]!=0 && (l[i][j])->suivant==NULL){
						ligne_supp(grille[i][j], p, l, taille);
						colonne_supp(grille[i][j], p, l, taille);
						region_supp(grille[i][j], p, l, taille);
						trouve[i][j]=true;
						operation=true;
					}
					/* Si la case contient 0 et la liste ne contient qu'un element,
					on met le chiffre de la liste dans la case,
					on supprime la possibilit d'avoir le chiffre dans la ligne, dans la colonne et dans la region */
					else if(grille[i][j]==0 && (l[i][j])->suivant==NULL){
						grille[i][j] = (l[i][j])->valeur;
						ligne_supp(grille[i][j], p, l, taille);
						colonne_supp(grille[i][j], p, l, taille);
						region_supp(grille[i][j], p, l, taille);
						operation=true;
					}
					/* Si la case contient 0 et la liste contient plus d'un element */
					/* On teste chaque chiffre */
					else if(grille[i][j]==0 && (l[i][j])->suivant!=NULL){
						for(chiffre=1; chiffre<=taille; chiffre++){
							/* Si le chiffre n'appartient qu' cette liste dans la region,
							on place le chiffre dans la case,
							on supprime les autres chiffres de la liste,
							on supprime la possibilit d'avoir le chiffre dans la ligne et dans la colonne */
							if(region_nbfois(chiffre, p, l, taille)==1 && presence(l[i][j], chiffre)==true){
								grille[i][j] = chiffre;
								l[i][j] = supp_tous_sauf(grille[i][j], l[i][j]);
								ligne_supp(grille[i][j], p, l, taille);
								colonne_supp(grille[i][j], p, l, taille);
								operation=true;
							}
							/* Si le chiffre n'appartient qu' cette liste dans la ligne,
							on place le chiffre dans la case,
							on supprime les autres chiffres de la liste,
							on supprime la possibilit d'avoir le chiffre dans la colonne et dans la region */
							if(ligne_nbfois(chiffre, p, l, taille)==1 && presence(l[i][j], chiffre)==true){
								grille[i][j] = chiffre;
								l[i][j] = supp_tous_sauf(grille[i][j], l[i][j]);
								colonne_supp(grille[i][j], p, l, taille);
								region_supp(grille[i][j], p, l, taille);
								operation=true;
							}
							/* Si le chiffre n'appartient qu' cette liste dans la colonne,
							on place le chiffre dans la case,
							on supprime les autres chiffres de la liste,
							on supprime la possibilit d'avoir le chiffre dans la ligne et dans la region */
							if(colonne_nbfois(chiffre, p, l, taille)==1 && presence(l[i][j], chiffre)==true){
								grille[i][j] = chiffre;
								l[i][j] = supp_tous_sauf(grille[i][j], l[i][j]);
								ligne_supp(grille[i][j], p, l, taille);
								region_supp(grille[i][j], p, l, taille);
								operation=true;
							}
						}
					}
				}
			}
		}
	}
	while(operation==1);
	/* On effectue la boucle tant que des operations sont effectue */

	for (i=0;i<taille;i++){
		free(l[i]);
  }
	free(l);

	return rempli(grille, taille);
}
